' Programming Information
' Programming Date: 27 Feb 04
' Version: 1
'
' v_ are variables
' c_ are constants
' l_ are labels
' s_ are subroutines
'

' Definitions
DEFINE c_jyup,$FE	' Joystick pushed up value
DEFINE c_jydn,$FC	' Joystick pushed down value
DEFINE c_jyrt,$FA	' Joystick pushed right value
DEFINE c_jylt,$EE	' Joystick pushed left value
DEFINE c_strt,$EC	' START key value
DEFINE c_rset,$EA	' RESET key value
DEFINE c_t10,$DE	' Thrust 0% with KEY 0 press
DEFINE c_t11,$DC	' Thrust 100% with KEY 1 press
DEFINE v_gtky,$DA	' Get KEY value
DEFINE v_p1x,$BE	' Player 1's x coordinate
DEFINE v_p1Y,$BC	' Player 1's y coordinate
DEFINE v_Z,$BA
	
' Constants
c_jyup=$21
c_jydn=$DC
c_jyrt=$DC
c_jylt=$21
c_strt=$0C
c_rset=$0B
c_t10=$00
c_t11=$01

' Varaibles
v_gtky=0
v_p1x=50
v_p1y=50
	

' Main Program

l_Main:     
TITLE "SPACE SHIP"
AUTHOR "montotronix"

KEYPAD 0	' Joystick 1's input for keys
SCREEN 2	' Can only be a 2 or 4 ... with a 2, text comes out nice; with a 4, not so much
SPRITES ON

l_SetColors:
PALETTE $00,$00		' Set background ($00) color to black ($00)
PALETTE $05,$44		' Set Sprite Color 1 ($05) color to purple ($44) 
PALETTE $06,$60		' Set Sprite Color 2 ($06) color to blue ($60)
PALETTE $07,$CA		' Set Sprite Color 3 ($07) color to who knows... ($CA)
PALETTE $08,$FF		' Set Sprite Color 4 ($08) color to who knows... ($FF)


CLS

DO
 PUT (v_p1x,v_p1y),$90,0,8	' Put l_ship sprite#0 8 scan lines high at c_player1x coord, c_player1y coord
 X=v_p1y:X=X+1:X=X+1:X=X+1:X=X+1:X=X+1:X=X+1:X=X+1:X=X+1:X=X+1:X=X+1:v_Z=X	' Move the ship down 10 scan lines
 PUT (v_p1x,v_Z),l_Ship,1,8

 
 A = v_p1x		' Addition and subtraction can only be accomplished on A/X/Y register
 A=A - 1		' Move the ship one byte to the left
 IF A < 1 THEN		' If ship at left edge of screen, then...
  v_p1x = 159		' move it to the right edge of screen
 ELSE			' otherwise, ...
  v_p1x = A		' put the new location back into the v_player1x coordinate
 END IF
 
 v_Z=0:FOR v_Z TO 100:NEXT v_Z		'Small delay, this may do nothing

 
 A = INKEY		' Looking for escape key of *
LOOP UNTIL A = c_rset	' Escape if you got the *

PRINT "DONE!"		' Let you know your out of the loop


l_Ship:		' Labels dont work well here, better just stick to address or INCLUDEs		
.ORG $9000	
.BYTE $10 	;00010000
.BYTE $10 	;00010000
.BYTE $10 	;00010000
.BYTE $38 	;00111000
.BYTE $7C 	;01111100
.BYTE $FE 	;11111110
.BYTE $38 	;00111000
.BYTE $44 	;01000100


'End Program

'How To Compile
'5200bas {filename}.bas
'tasm -65 -b -fFF -q {filename}.asm {filename}.bin